"""
Carlos J Corrada Bravo
Este programa calcula el promedio de tiempo de ejecucion de cuatro algoritmos de ordenamiento
La variable maxValor define el valor maximo de los elementos de la lista
La variable largoLista define el largo de las listas a ordenar
La variable veces define las veces que se va a hacer el ordenamiento 
Al final se imprimen los promedios de cada algortimo
"""
from random import randint
import time
from merge import merge
import heapify # Se importa esa librería para usar heapify

'''
 Python program for implementation of MergeSort  taken from https://www.geeksforgeeks.org/python-program-for-merge-sort/#:~:text=Merge%20Sort%20is%20a%20Divide,assumes%20that%20arr%5Bl..
 Merges two subarrays of arr[].
 First subarray is arr[l..m]
 Second subarray is arr[m+1..r]
'''


def mergeSort(lista, l, r):
	if l < r:
		# Same as (l+r)//2, but avoids overflow for
		# large l and h
		m = l + (r - l) // 2

		# Sort first and second halves
		mergeSort(lista, l, m)
		mergeSort(lista, m + 1, r)
		merge(lista, l, m, r)

""" Código tomado de GeeksForGeeks.
	Enlace electrónico del código 
 	encontrado y adaptado para la
  	asignación o el proyecto de prác-
   	tica con git: https://www.geeksforgeeks.org/heap-sort/
"""
def heapSort(lista):
	#definan el algoritmo de ordenamiento heapsort
	heapq.heapify(lista)
 
	# Se busca el tamaño de la lista
	n = len(lista)
 
	""" Se crea un heap máximo y el último padre estará en
		la posición h1, i.e., la mitad del tamaño de la lista.
		Por lo tanto, ese sería el comienzo. 
	"""
	h1 = (n // 2) - 1
	for i in range(h1, -1, -1):
		heapq.heapify(lista[i])
  
	# Se extrae los elementos uno a uno
	for i in range(n-1, 0, -1):
		# Se intercambia, luego se hace heapify
		lista[i], lista[0] = lista[0], lista[i]
		heapq.heapify(lista[i])
  
	return lista

def quickSort(lista):
	#definan el algoritmo de ordenamiento quicksort
	return lista


''' 
	This algorithm was taken from: https://www.programiz.com/dsa/shell-sort 
	and was adapted in order to work for this assigment.
'''


def shellSort(lista):
	# Determine the list size to find the gap.
	n = len(lista)
	gap = n // 2

	# this algorithm will run until gap reaches 1
	while gap > 0:
		for i in range(gap, n):
			temp = lista[i]  # storing all items from lista into temp
			j = i

			# compares the number in temp with the 0th possition (start of list)
			# if temp is larger than the first element then we swap them
			while j >= gap and lista[j - gap] > temp:
				lista[j] = lista[j - gap]
				j -= gap

			lista[j] = temp
		gap = gap // 2  # decreases the gap to continue the loop

	return lista

maxValor=1000 	#define el valor maximo de los elementos de la lista
largoLista=1000 #define el largo de las listas a ordenar
veces=100 		#define las veces que se va a hacer el ordenamiento 

acumulaMerge=0 	#variable para acumular el tiempo de ejecucion del mergesort
acumulaHeap=0 	#variable para acumular el tiempo de ejecucion del heapsort
acumulaQuick=0 	#variable para acumular el tiempo de ejecucion del quicksort
acumulaShell=0 	#variable para acumular el tiempo de ejecucion del shellsort

for i in range(veces):
	mergelista = [randint(0,maxValor) for r in range(largoLista)] #creamos una lista con valores al azar
	heaplista=list(mergelista)
	quicklista=list(mergelista)
	searchlista=list(mergelista)

	t1 = time.clock() 				#seteamos el tiempo al empezar
	mergeSort(mergelista) 				#ejecutamos el algoritmo mergeSort
	acumulaMerge += time.process_time()-t1 	#acumulamos el tiempo de ejecucion
	
	t1 = time.clock()				#seteamos el tiempo al empezar
	heapSort(heaplista)					#ejecutamos el algoritmo heapSort
	acumulaHeap += time.process_time()-t1  # acumulamos el tiempo de ejecucion
	
	t1 = time.clock()				#seteamos el tiempo al empezar
	quickSort(quicklista)				#ejecutamos el algoritmo quickSort
	acumulaQuick += time.process_time()-t1  # acumulamos el tiempo de ejecucion
	
	t1 = time.clock()				#seteamos el tiempo al empezar
	shellSort(searchlista)				#ejecutamos el algoritmo shellSort
	acumulaShell += time.process_time()-t1  # acumulamos el tiempo de ejecucion

#imprimos los resultados
print "Promedio de tiempo de ejecucion de "+ str(veces) +" listas de largo " + str(largoLista)
print "MergeSort " + str(acumulaMerge/veces) + " segundos"
print "HeapSort " + str(acumulaHeap/veces) + " segundos"
print "QuickSort " + str(acumulaQuick/veces) + " segundos"
print "ShellSort " + str(acumulaShell/veces) + " segundos"

